local addonName = "BiggerFishToFryTracker"
local version = "1.5.1"

local bfft = CreateFrame("Frame","BiggerFishToFryTracker",UIParent,"BasicFrameTemplateWithInset")
bfft.achievementId = 10596

bfft.zone_Azsuna = { "LeyShimmer Blenny", "Nar'thalas Hermit", "Ghostly Queenfish" }
bfft.zone_ValSharah = { "Ancient Mossgill", "Thorned Flounder", "Terrorfin" }
bfft.zone_HighMountain = { "Mountain Puffer", "Ancient Highmountain Salmon", "Coldriver Carp" }
bfft.zone_Stormheim = { "Oodelfjisk", "Thundering Stormray", "Graybelly Lobster" }
bfft.zone_Suramar = { "Magic-Eater Frog", "Tainted Runescale Koi", "Seerspine Puffer" }
bfft.zone_Ocean = { "Seabottom Squid", "Axefish", "Ancient Black Barracuda" }


local colors = 
{
    white = "|cffffffff",
    green = "|cff00ff00",
    red = "|cffff0000",
}

bfft.fish2subachievementIndex = 
{
    ["Ancient Black Barracuda"] = 1,
	["Ancient Highmountain Salmon"] = 2,
	["Ancient Mossgill"] = 3,
	["Axefish"] = 4,
	["Coldriver Carp"] = 5,
	["Ghostly Queenfish"] = 6,
	["Graybelly Lobster"] = 7,
	["LeyShimmer Blenny"] = 8,
	["Magic-Eater Frog"] = 9,
	["Mountain Puffer"] = 10,
	["Nar'thalas Hermit"] = 11,
	["Oodelfjisk"] = 12,
	["Seabottom Squid"] = 13,
	["Tainted Runescale Koi"] = 14,
	["Thundering Stormray"] = 15,
	["Seerspine Puffer"] = 16,
	["Terrorfin"] = 17,
	["Thorned Flounder"] = 18,
}

bfft.fish2primarylure =
{
    ["LeyShimmer Blenny"] = "Skrog Toenail",
    ["Nar'thalas Hermit"] = "Pearlescent Conch",
    ["Ghostly Queenfish"] = "Rusty Queenfish Brooch",
    ["Ancient Mossgill"] = "Rotten Fishbone",
    ["Thorned Flounder"] = "Drowned Thistleleaf",
    ["Terrorfin"] = "Nightmare Nightcrawler",
    ["Mountain Puffer"] = "Swollen Murloc Egg",
    ["Ancient Highmountain Salmon"] = "Funky Sea Snail",
    ["Coldriver Carp"] = "Frost Worm",
    ["Oodelfjisk"] = "Ancient Vrykul Ring",
    ["Thundering Stormray"] = "Moosehorn Hook",
    ["Graybelly Lobster"] = "Soggy Drakescale",
    ["Magic-Eater Frog"] = "Enchanted Lure",
    ["Tainted Runescale Koi"] = "Demonic Detritus",
    ["Seerspine Puffer"] = "Sleeping Murloc",
    ["Seabottom Squid"] = "Stunned, Angry Shark",
    ["Axefish"] = "Message in a Beer Bottle",
    ["Ancient Black Barracuda"] = "Decayed Whale Blubber",
}

bfft.fish2secondarylure =
{
    ["LeyShimmer Blenny"] = "Aromatic Murloc Slime",
    ["Ancient Highmountain Salmon"] = "Salmon Lure",
    ["Thundering Stormray"] = "Silverscale Minnow",
    ["Axefish"] = "Axefish Lure",
    ["Ancient Black Barracuda"] = "Ravenous Fly",
}

bfft.lure2itemID =
{
    ["Skrog Toenail"] = 133701,
    ["Pearlescent Conch"] = 133703,
    ["Rusty Queenfish Brooch"] = 133704,
    ["Rotten Fishbone"] = 133705,
    ["Drowned Thistleleaf"] = 133708,
    ["Nightmare Nightcrawler"] = 133707,
    ["Aromatic Murloc Slime"] = 133702,
    ["Swollen Murloc Egg"] = 133711,
    ["Funky Sea Snail"] = 133709,
    ["Salmon Lure"] = 133710,
    ["Frost Worm"] = 133712,
    ["Ancient Vrykul Ring"] = 133715,
    ["Moosehorn Hook"] = 133713,
    ["Silverscale Minnow"] = 133714,
    ["Soggy Drakescale"] = 133716,
    ["Enchanted Lure"] = 133717,
    ["Demonic Detritus"] = 133720,
    ["Sleeping Murloc"] = 133719,
    ["Stunned, Angry Shark"] = 133723,
    ["Message in a Beer Bottle"] = 133721,
    ["Axefish Lure"] = 133722,
    ["Decayed Whale Blubber"] = 133724,
    ["Ravenous Fly"] = 133795,
}

bfft.action =
{
    ["Ancient Black Barracuda"] = " -> click on fly that will appear TIP: use on land! ->",
    ["Ancient Highmountain Salmon"] = " -> attacked by Drogbar ->",
    ["Ancient Mossgill"] = " -> druid appears and gives buff",
    ["Axefish"] = " -> contains bait: ",
    ["Coldriver Carp"] = "",
	["Ghostly Queenfish"] = " -> see Ghostly Queenfish Pools",
    ["Graybelly Lobster"] = "",
	["LeyShimmer Blenny"] = " -> attacked by Murloc ->",
    ["Magic-Eater Frog"] = "",
	["Mountain Puffer"] = " -> dancing baby murloc (gives buff)",
	["Nar'thalas Hermit"] = "",
	["Oodelfjisk"] = " -> see Oodelfjisk schools",
    ["Seabottom Squid"] = " -> kill shark (beware mouth) TIP: use in a minute or it disappears !!! use on land with room to kite",
	["Tainted Runescale Koi"] = "",
	["Thundering Stormray"] = " -> fish up bait: ",
	["Seerspine Puffer"] = " -> murloc runs away (run over dropped fish) TIP: use on vegetation-sparse land",
	["Terrorfin"] = "",
	["Thorned Flounder"] = "",
}

local function GetLureAnnotation(name)

    local primaryLure = bfft.fish2primarylure[name];
    local _, primaryLureLink = GetItemInfo (bfft.lure2itemID[primaryLure]);

    if (primaryLureLink == nil) then
        primaryLureLink = primaryLure;
    end
    
    local secondaryLure = bfft.fish2secondarylure[name];
    local secondaryLureLink;
	
    if (secondaryLure == nil) then
        secondaryLureLink = "";
	else
        _, secondaryLureLink = GetItemInfo (bfft.lure2itemID[secondaryLure]);

		if (secondaryLureLink == nil) then
            secondaryLureLink = "";
        end
    end

    return
		primaryLureLink .. bfft.action[name] .. secondaryLureLink;

end

local function PrintResults (name, completed)

    if (completed) then colorString = colors.green else colorString = colors.red end
    print (string.format ("%s%s%s (%s)", colorString, name, colors.white, GetLureAnnotation(name)));

end

local function ReportFishZone(zoneName, criteriaList, lures)

    local completedFish = 0;
    local totalFish = 0;

    for key, value in pairs (criteriaList) do
		totalFish = totalFish + 1;
        local name, _, completed = GetAchievementCriteriaInfo (bfft.achievementId, bfft.fish2subachievementIndex[value])
        if (completed) then completedFish = completedFish + 1 end;
        PrintResults (value, completed)
    end
    print (string.format ("completed %d of %d for zone", completedFish, totalFish));

end

local function StripString(pattern)

    local patternBare = string.gsub (pattern, " ", "")
    patternBare = string.gsub (patternBare, "'", "")
    patternBare = string.lower (patternBare)

	return patternBare

end

local function ReportSingleZoneIfMatch(pattern, superString, fishList, lures)

    local patternBare = StripString (pattern)
    local superStringBare = StripString(superString)

    if (string.find (superStringBare, patternBare) ~= nil) then
        print (" ")
        print (string.format ("Rare fish in %s", superString))
        ReportFishZone (superString, fishList, lures)
    end
end

local function ShowLures (message)
	
    if (string.find (message, "lures") == nil) then
        return false
    else
		return true
    end
end

local function ReportRareFish (msg, editbox)

    local showLures = ShowLures(msg)
    local zone = string.gsub(msg, "lures", "")

    print (string.format ("Bigger Fish to Fry Tracker v %s", version))
    print ("Based on the wowhead guide 'The Underlight Angler - A Step by Step Guide to Obtaining Legion's Fishing Artifact' by madseasonshow")
	
    zone = StripString(zone)
    if (string.lower (zone) == "local" or string.lower (zone) == "this") then
		zone = GetZoneText()
    end

    print (string.format ("Request rare fish not yet caught in zone(s) matching:  %s", zone));

    if (zone == "all") then
		zone = ""
	end

	if (zone ~= "?") then

		ReportSingleZoneIfMatch (zone, "Azsuna", bfft.zone_Azsuna, showLures)
        ReportSingleZoneIfMatch (zone, "Val'Sharah", bfft.zone_ValSharah, showLures)
        ReportSingleZoneIfMatch (zone, "Highmountain", bfft.zone_HighMountain, showLures)
        ReportSingleZoneIfMatch (zone, "Stormheim", bfft.zone_Stormheim, showLures)
        ReportSingleZoneIfMatch (zone, "Suramar", bfft.zone_Suramar, showLures)
		ReportSingleZoneIfMatch (zone, "Ocean", bfft.zone_Ocean, showLures)

    else

        print ("Usage:  ")
        print ("/bfft  or  /bfft all  - gives a summary of all zones")
        print ("/bfft <any part of the zone name> - gives results for all zones which match eg. /bfft val")
        print ("/bfft this - results for the zone you are currently in (if any)")
        print ("/bfft <zone> lures - shows lures for requested zone (named/all/this)")

    end
    print (" ")

end

-- slash handler (/bfft)
SLASH_BFFT1 = "/bfft"
SlashCmdList["BFFT"] = ReportRareFish
